/*
 * UserMap.java
 *
 * Created on September 30, 2003, 3:47 PM
 */

/**
 *
 * @author  Nathan
 */

import java.io.*;
import java.util.*;

public class UserMap extends HashMap{
    
    /** Creates a new instance of UserMap */
    public UserMap() {
    }
 
    /** Creates the default users names and passwords for the chat program
     *   and saves them as a file. */
    public void createDefaultUsers() {
        // add the default user to the Collection
        this.put("john", new User("john", "john"));
        this.put("david", new User("david", "david"));
        this.put("jennifer", new User("jennifer", "jennifer"));
        this.put("mary", new User("mary", "mary"));        
        try{
            // create a stream and save the users to a file
            ObjectOutputStream out = new ObjectOutputStream(
               new FileOutputStream("chat.dat"));
            out.writeObject(this);
            out.close();
        }
        catch(IOException e){
            System.err.println("Error creating the default file");
            System.err.println("Unexpected IO ERROR: " + e);    
        }
    }    

    /** Opens file of the saved list of users. */    
    public Map open() throws IOException, ClassNotFoundException{
        ObjectInputStream in = new ObjectInputStream( new
            FileInputStream("chat.dat"));
        Object o = in.readObject();
        Map map = (Map)o;
        return map;
    }
    
    /** Saves the changes made to the list to the file.  */
    public void save(){
        try{
            ObjectOutputStream out = new ObjectOutputStream(
               new FileOutputStream("chat.dat"));
            out.writeObject(this);
            out.close();
        }
        catch(IOException e){
            System.err.println("Unable to save the file");
            System.err.println("Unexpected IO ERROR: " + e);    
        }       
    }
}
